'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          block = _props.block,
          context = _props.context,
          disabled = _props.disabled,
          outline = _props.outline,
          id = _props.id,
          onClick = _props.onClick,
          size = _props.size,
          utilityClasses = _props.utilityClasses;

      var cssClasses = 'btn';
      var attributes = {};
      cssClasses += outline ? ' outline-' : ' btn-';
      if (context) {
        cssClasses += ' btn-' + context;
      }
      switch (size) {
        case 'small':
          cssClasses += ' btn-sm';
          break;
        case 'large':
          cssClasses += ' btn-lg';
          break;
      }

      cssClasses += block ? ' btn-block' : '';

      if (disabled) {
        cssClasses += ' disabled';
        attributes['disabled'] = true;
        attributes['aria-disabled'] = true;
      }
      if (utilityClasses) {
        cssClasses += ' ' + utilityClasses;
      }

      if (onClick) {
        attributes = Object.assign({}, attributes, { onClick: onClick });
      }
      return _react2.default.createElement(
        'button',
        _extends({ id: 'button-' + id, context: 'button', className: cssClasses, onClick: onClick }, attributes),
        this.props.children
      );
    }
  }]);

  return Button;
}(_react2.default.Component);

Button.defaultProps = {
  block: false,
  disabled: false,
  outline: false,
  size: 'medium',
  context: 'light',
  utilityClasses: ''
};
Button.propTypes = {
  block: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  disabled: _propTypes2.default.bool,
  id: _propTypes2.default.string.isRequired,
  onClick: _propTypes2.default.func,
  outline: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(['small', 'medium', 'large']),
  context: _propTypes2.default.oneOf(['danger', 'dark', 'info', 'light', 'link', 'primary', 'secondary', 'success', 'warning']),
  utilityClasses: _propTypes2.default.string
};
exports.default = Button;