'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextArea = function (_React$Component) {
  _inherits(TextArea, _React$Component);

  function TextArea() {
    _classCallCheck(this, TextArea);

    return _possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).apply(this, arguments));
  }

  _createClass(TextArea, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          cols = _props.cols,
          cssClass = _props.cssClass,
          disabled = _props.disabled,
          id = _props.id,
          maxlength = _props.maxlength,
          onChange = _props.onChange,
          placeholder = _props.placeholder,
          required = _props.required,
          rows = _props.rows,
          value = _props.value;

      if (cssClass) {
        cssClass = 'form-control ' + cssClass;
      } else {
        cssClass = 'form-control';
      }
      return _react2.default.createElement(
        'textarea',
        {
          className: cssClass,
          cols: cols,
          disabled: disabled,
          id: 'form-control-' + id,
          maxLength: maxlength,
          name: 'id',
          onChange: onChange,
          placeholder: placeholder,
          rows: rows,
          required: required
        },
        value
      );
    }
  }]);

  return TextArea;
}(_react2.default.Component);

TextArea.defaultProps = {
  autofocus: false,
  cols: 80,
  disabled: false,
  maxlength: 1024,
  required: false,
  rows: 20
};
TextArea.propTypes = {
  cols: _propTypes2.default.number,
  cssClass: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  id: _propTypes2.default.string.isRequired,
  maxlength: _propTypes2.default.number,
  onChange: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  rows: _propTypes2.default.number,
  value: _propTypes2.default.string.isRequired
};
exports.default = TextArea;