'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AppendAddon = require('./AppendAddon');

var _AppendAddon2 = _interopRequireDefault(_AppendAddon);

var _PrependAddon = require('./PrependAddon');

var _PrependAddon2 = _interopRequireDefault(_PrependAddon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputGroup = function (_React$Component) {
  _inherits(InputGroup, _React$Component);

  function InputGroup() {
    _classCallCheck(this, InputGroup);

    return _possibleConstructorReturn(this, (InputGroup.__proto__ || Object.getPrototypeOf(InputGroup)).apply(this, arguments));
  }

  _createClass(InputGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          appendText = _props.appendText,
          children = _props.children,
          id = _props.id,
          prependText = _props.prependText,
          size = _props.size;

      var prependComponent = '';
      var appendComponent = '';
      if (prependText) {
        prependComponent = _react2.default.createElement(
          _PrependAddon2.default,
          { id: id },
          prependText
        );
      }
      if (appendText) {
        appendComponent = _react2.default.createElement(
          _AppendAddon2.default,
          { id: id },
          appendText
        );
      }

      var className = 'input-group mb-3';
      switch (size) {
        case 'small':
          className += ' input-group-sm';
          break;
        case 'large':
          className += ' input-group-lg';
          break;
      }
      return _react2.default.createElement(
        'div',
        { id: 'InputGroup-' + id, className: className },
        prependComponent,
        children,
        appendComponent
      );
    }
  }]);

  return InputGroup;
}(_react2.default.Component);

InputGroup.defaultProps = {
  size: 'medium'
};
InputGroup.propTypes = {
  appendText: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  id: _propTypes2.default.string.isRequired,
  prependText: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['small', 'medium', 'large'])
};
exports.default = InputGroup;